<?php

declare(strict_types=1);

use Phinx\Migration\AbstractMigration;

final class CreatePromotion extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change(): void
    {
        $this->execute('SET unique_checks=0; SET foreign_key_checks=0;');
        $this->execute("ALTER DATABASE CHARACTER SET 'utf8mb4';");
        $this->execute("ALTER DATABASE COLLATE='utf8mb4_general_ci';");

        $this->table('promotions')
            ->addColumn('price_id', 'integer', ['signed' => false, 'null' => false])
            ->addColumn('amount', 'decimal', ['precision' => 10, 'scale' => 2, 'null' => false])
            ->addColumn('start_date', 'date', ['null' => false])
            ->addColumn('end_date', 'date', ['null' => false])
            ->addColumn('valid_until', 'date', ['null' => false])
            ->addColumn('state', 'integer', ['length' => 1, 'null' => false, 'default' => 1])
            ->addForeignKey('price_id', 'prices', 'id', ['delete' => 'cascade', 'update' => 'cascade'])
            ->create();

        $this->execute('SET unique_checks=1; SET foreign_key_checks=1;');
    }
}
